
import dbus
import unittest

from tests.utils import (
    setup_test_env,
)
setup_test_env()

from softwarecenter.db.dataprovider import SoftwareCenterDataProvider


class DataProviderTestCase(unittest.TestCase):

    @classmethod
    def setUpClass(cls):
        # FIXME: get a private test bus here instead
        cls.bus = dbus.SessionBus()
        bus_name = dbus.service.BusName(
            'com.ubuntu.SoftwareCenterDataProvider', cls.bus)
        # get the provider
        cls.provider = SoftwareCenterDataProvider(bus_name)

    @classmethod
    def tearDownClass(cls):
        cls.provider.stop()
    
    def test_have_data_in_db(self):
        self.assertTrue(len(self.provider.db) > 100)

    def test_get_details(self):
        result = self.provider.GetAppDetails("", "software-center")
        self.assertEqual(result["component"], "main")
        self.assertEqual(result["icon"], "softwarecenter")
        self.assertEqual(result["name"], "software-center")
        self.assertEqual(result["pkgname"], "software-center")


if __name__ == "__main__":
    unittest.main()
